#include "context.h"
#include "buffer.h"
#include "strerr.h"

Context to_space_context(Context x, Context lastx)
{
    x.flags &= ~(S | EM | I | B);
    x.flags |= lastx.flags & (S | EM | I | B);
    if ((x.flags & U) == 0) x.color = lastx.color;
    return x;
}

int
Context_diff(Context a, Context b)
{
    return a.flags != b.flags || a.size != b.size || a.color != b.color;
}

void
Context_dump(Context x)
{
    char s[50];
    char *p = s;

    if (x.flags & U) {
	int u = x.flags & U;
	while (u > 0) {
	    *p++ = 'U';
	    u--;
	}
	*p++ = ' ';
    }

    if (x.flags & B) {
	*p++ = 'B';
	*p++ = ' ';
    }

    if (x.flags & I) {
	*p++ = 'I';
	*p++ = ' ';
    }

    if (x.flags & S) {
	*p++ = 'S';
	*p++ = ' ';
    }

    if (x.flags & EM) {
	*p++ = 'E';
	*p++ = 'M';
	*p++ = ' ';
    }

    if (x.flags & TT) {
	*p++ = 'T';
	*p++ = 'T';
	*p++ = ' ';
    }

    if (x.size) {
	*p++ = x.size;
	*p++ = ' ';
    }

    if (x.color) {
	*p++ = x.color;
	*p++ = ' ';
    }

    if (p > s) {
	if (buffer_put(buffer_1, s, (p - s) - 1) < 0)
	    strerr_die1sys(1, "write");
    }
}

